;TAPMASTER 2.0                                                                                                           ;(c) 1996 Mr. Johnny RENEGADE                                                                                       ;Utilita TAPmaster slouzi k importu souboru .TAP z emulatoruzpet do Spectra.                                             ;Nejprve si musite soubor importovat nejakym zpusobem na BS-DOSovy disk. Pak nahrajte TAPMASTER (pozor, program bezi ;veVRAM!), nastavte load kurzor na TAP soubor (prikaz ` cislosouboru) a spustte Tapika prikazem CONTINUE 16384.  ;Disketa si bude chvilku chrochtat (blahem). Mozna bude i blikat border (k ukladani souboru na disk je pouzita ROMkova ;rutina #04c2, ktera po svem ukonceni nastavuje border dle  adresy 23624; TAPMASTER pouziva pamet od 23296 jako  ;bufer). Po dokonceni exportu obdrzite hlasku 'Done' a po jejim odpalkovani se pocitac NEWne (proto je tam ta hlaska ;aby bylo poznat ze korektne skoncil :-). Jedine omezeni programu tkvi v tom, ze nemuze exportovat soubory delsi ;42240 ;bajtu. Pokud se takovy soubor vyskytne, dojde pri exportu k prepsani DOSu a je nutno rebootovat.                        ;                                                                                                                        ;              KEEP SPECCY ALIVE!                       


	output "tapmaster.bin"

SPCKO      EQU #4800		;(SP) stack pointer

DATA_START EQU #5B00		;start of data buffer, max block length= 42240 bytes (#5B00-#FFFF)
HEAD32     EQU #4300		;start of 32 byte header


        ORG #4000		
 ;TAPmaster disassembling by Hood 2017-2018


START   DI
        LD   SP,SPCKO

        LD   HL,(#5CB4)
  	;23732, P RAMT, address of the last byte of physical RAM
        PUSH HL
        LD   HL,(#5C38)		;23608, RASP (1), length of warning buzz
        PUSH HL
        LD   HL,(#5C7B)		;23675, UDG (2), address of 1st user defined graphic
        PUSH HL
        CALL #3C9E
        LD   HL,SPCKO
        LD   DE,SPCKO+1
        LD   B,#13
        LD   (HL),L
        LDIR 			;clear screen

        LD   A,#46

        LD   (#3E2),A		;COLOR for screen print

        LD   HL,#900

        LD   (#3E0),HL		;XXX,YYY- print column and line

        XOR  A

        OUT  (#FE),A

        LD   E,A

        LD   A,#C

        RST  #20		;display mode= 0

        LD   HL,INFO_T

        LD   A,#4

        RST  #20		;print text "TAPmaster 2.0..."

        LD   A,#12

        RST  #20		;find out load cursor position

        LD   (LOA_KUR),HL

        LD   HL,#0

        LD   (DATA12),HL

        LD   HL,#FFFF

        LD   (ZACIAT_SEC),HL

        CALL JUMP1
JUMP3   LD   HL,SAVE_LEN

        LD   DE,#3

        CALL MAIN_L

        LD   HL,DATA_START

        LD   DE,(SAVE_LEN)

        DEC  DE

        CALL MAIN_L

        CALL #3C98
        LD   IX,DATA_START
        LD   DE,(SAVE_LEN)

        DEC  DE

        DEC  DE

        LD   A,(SAVE_FLAG)

        CALL #4C2		;save block, IX= block start, DE= length, A= flag byte

        CALL #3C9E

        JR   JUMP3



JUMP1   LD   BC,(LOA_KUR)

        LD   IX,HEAD32

        LD   A,#16

        RST  #20		;read TAP 32 byte header

        LD   HL,(HEAD32+#18)	

        LD   DE,(HEAD32+#1A)	;read its length

        PUSH HL

        LD   A,#F		;find out length in sector

        RST  #20

        LD   (POCET_SEC),BC
        POP  HL

        LD   A,#3

        AND  H

        LD   H,A

        OR   L

        JR   NZ,JUMP1_1

        LD   H,#4

JUMP1_1 LD   (DATA9),HL

        RET

MAIN_L  LD   (DATA10),HL

        LD   (DATA11),DE

        LD   HL,(DATA12)

        LD   A,H

        OR   L

        JR   Z,MAIN_L1

        CALL SUBSTR

        LD   B,H

        LD   C,L

        LD   HL,(DATA13)

        LD   DE,(DATA10)

        PUSH BC

        LDIR
        POP  BC
        LD   (DATA10),DE
        LD   (DATA13),HL
        LD   HL,(DATA12)

        AND  A

        SBC  HL,BC

        LD   (DATA12),HL

        LD   HL,(DATA11)

        SBC  HL,BC

        LD   (DATA11),HL

        RET  Z

MAIN_L1 LD   HL,(POCET_SEC)

        LD   A,H

        OR   L

        JP   Z,END        	;if all sectors processed, end
        DEC  HL

        LD   (POCET_SEC),HL

        LD   HL,(LOA_KUR)
        LD   IX,HEAD32

        LD   BC,(ZACIAT_SEC)

        INC  BC

        LD   (ZACIAT_SEC),BC
        LD   E,#1

        LD   A,#23

        RST  #20		;load one sector from address HEAD32

        LD   HL,(POCET_SEC)

        LD   A,H

        OR   L

        LD   HL,#400

        JR   NZ,MAIN_L2

        LD   HL,(DATA9)
MAIN_L2 LD   (DATA12),HL

        LD   HL,HEAD32

        LD   (DATA13),HL

        LD   HL,(DATA10)
        LD   DE,(DATA11)

        JR   MAIN_L



END     LD   HL,DONE

        LD   A,#34

        RST  #20

        CALL #3C98

        POP  HL

        POP  HL
        POP  DE
        POP  BC

        EXX

        LD   A,#FF
        LD   DE,#5FFF

        JP   #11CB		;NEW command



SUBSTR  PUSH HL
        AND  A
        SBC  HL,DE
        POP  HL
        RET  C

        LD   H,D

        LD   L,E

        RET



DONE    DB "Done"
        DB 0,#C9



INFO_T  DB ".TAPmaster 2.0 by Johny RENEGADE",0		;missing #C9 here???


LOA_KUR    DB #55,#55

ZACIAT_SEC DB #55,#55

DATA12     DB #55,#55

DATA13     DB #55,#55
POCET_SEC  DB #55,#55

DATA9      DB #55,#55

DATA10     DB #55,#55

DATA11     DB #55,#55

SAVE_LEN   DB #55,#55

SAVE_FLAG  DB #55
	
TOT_LEN=$-START


  
